﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BaseApplicationProject
{
    public class MyEntities
    {
        public ObservableCollection<dbProduct> dbProduct { get; set; }
        public ObservableCollection<dbOrder> dbOrder { get; set; }

        public MyEntities()
        {
            this.dbProduct = new ObservableCollection<dbProduct>()
            {
                new dbProduct() { Name = "Product 1"},
                new dbProduct() { Name = "Product 2"},
                new dbProduct() { Name = "Product 3"},
                new dbProduct() { Name = "Product 4"},
                new dbProduct() { Name = "Product 5"},
                new dbProduct() { Name = "Product 6"},
                new dbProduct() { Name = "Product 7"},

            };

            this.dbOrder = new ObservableCollection<dbOrder>()
            {
                new dbOrder() 
                { 
                    Name = "Order A",
                    dbOrderProducts = new ObservableCollection<dbProduct>() 
                    {
                         new dbProduct() { Name = "Product 1.1"},
                         new dbProduct() { Name = "Product 1.2"},
                         this.dbProduct[0]
                    } 
                },
                new dbOrder() 
                { 
                    Name = "Order B",
                    dbOrderProducts = new ObservableCollection<dbProduct>() 
                    {
                         new dbProduct() { Name = "Product 2.1"},
                         new dbProduct() { Name = "Product 2.2"},
                         this.dbProduct[0]
                    } 
                },
                new dbOrder() 
                { 
                    Name = "Order C",
                    dbOrderProducts = new ObservableCollection<dbProduct>() 
                    {
                         new dbProduct() { Name = "Product 3.1"},
                         new dbProduct() { Name = "Product 3.2"},
                    } 
                }
            };
        }
    }

    public class dbProduct
    {
        public string Name { get; set; }
        public dbOrder Order { get; set; }
    }

    public class dbOrder
    {
        public string Name { get; set; }
        public dbOrder()
        {
            this.dbOrderProducts = new ObservableCollection<dbProduct>();
        }
        public ObservableCollection<dbProduct> dbOrderProducts { get; set; }
    }

    public class OrderGroup
    {   
        public dbOrder OrderInfo { get; set; }
        public ObservableCollection<dbProduct> OrderProducts { get; set; }

        public OrderGroup(dbOrder order)
        {
            this.OrderInfo = order;
            this.OrderProducts = new ObservableCollection<dbProduct>();
            foreach (dbProduct product in order.dbOrderProducts)
            {
                var newProduct = new dbProduct();
                newProduct.Name = product.Name;

                this.OrderProducts.Add(newProduct);

                // If you comment the above part of the loop and uncomment the line below, the selection issue will appear
                //this.OrderProducts.Add(product);
            }


            // THE ORIGINAL CODE
            //this.OrderInfo = order;
            //OrderProducts = new ObservableCollection<dbProduct>();
            //foreach (dbProduct product in order.dbOrderProducts.Select(x => x.dbProduct))
            //    this.OrderProducts.Add(product);
        }
    }
}
